putlog "Chargement de IriX Version Eggdrop ..."
set cs::time [time {
namespace eval cs {
  source [file join scripts CSconfig.tcl]
  source [file join scripts CSoutils.tcl]
}

########################################################

bind msg - csauth cs::csauth
bind msg - auth cs::auth
bind msg - adminreg cs::adminreg
bind msg - delchan cs::delchan
bind msg - adduser cs::adduser
bind msg - deluser cs::deluser
bind msg - addadmin cs::addadmin
bind msg - deladmin cs::deladmin
bind msg - version cs::version
bind msg - csadmin cs::csadmin
bind msg - rehash cs::rehash
bind msg - restart cs::restart
bind msg - chanlist cs::chanlist
bind msg - newpass cs::newpass

bind pub - [set cs::char]delchan cs::Pdelchan
bind pub - [set cs::char]deluser cs::Pdeluser
bind pub - [set cs::char]deladmin cs::Pdeladmin
bind pub - [set cs::char]version cs::Pversion
bind pub - [set cs::char]csadmin cs::Pcsadmin
bind pub - [set cs::char]rehash cs::Prehash
bind pub - [set cs::char]restart cs::Prestart
bind pub - [set cs::char]chanlist cs::Pchanlist

autobind - op cs::op
autobind - deop cs::deop
autobind - voice cs::voice
autobind - devoice cs::devoice
autobind - access cs::access
autobind - alist cs::alist
autobind - kick cs::kick
autobind - info cs::infoline
autobind - ban cs::ban
autobind - kickban cs::kickban
autobind - unban cs::unban
autobind - clearbans cs::clearbans
autobind - banlist cs::banlist
autobind - strictop cs::strictop
autobind - strictmodes cs::strictmodes
autobind - lockmodes cs::lockmodes
autobind - locktopic cs::locktopic
autobind - autoops cs::autoops
autobind - setvoice cs::setvoice
autobind - noop cs::noop
autobind - noban cs::noban
autobind - voiceall cs::voiceall
autobind - devoiceall cs::devoiceall
autobind - opall cs::opall
autobind - deopall cs::deopall
autobind - mode cs::mode
autobind - defmodes cs::defmodes
autobind - rdefmodes cs::rdefmodes
autobind - clearmodes cs::clearmodes
autobind - say cs::say
autobind - do cs::do
autobind - topic cs::topic
autobind - deftopic cs::deftopic
autobind - rdeftopic cs::rdeftopic
autobind - rdefaults cs::rdefaults
autobind - moderate cs::moderate
autobind - chaninfo cs::chaninfo
autobind - showcommands cs::showcommands
autobind - bantimeout cs::bantimeout
autobind - banlevel cs::banlevel
autobind - chmodeslevel cs::chmodeslevel
autobind - addmask cs::addmask
autobind - delmask cs::delmask


########################################################

proc cs::newpass {nick host hand arg} {
 variable level
 variable chan-data
  set chan [string tolower [lindex $arg 0]]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(newpass)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 newpass "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if {[llength $arg]!=3} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick NEWPASS <#salon> <ancien mot de passe> <nouveau mot de passe>"
    return
  }
  set hpass [lindex $arg 1]
  set npass [lindex $arg 2]
  if {[string length $npass]<6} {
    putserv "NOTICE $nick :Le mot de passe doit contenir au moin 6 caractres."
    return
  }
  set x 0
  foreach d [set chan-data($chan)] {
    if {[lindex $d 0]=="ACCESS" && [stgcomp [lindex $d 1] [nick2hand $nick $chan]]} {
      if {[lindex $d 2]!=$hpass} {
        putserv "NOTICE $nick :Ancien mot de passe incorect."
        return
      }
      lset chan-data($chan) $x [join [lreplace [lindex [set chan-data($chan)] $x] 2 2 $npass]]
      putserv "NOTICE $nick :Votre mot de passe a t chang."
      dolog 1 newpass "$nick@[nick2hand $nick $chan] $chan"
      return
    }
    incr x
  }
  putserv "NOTICE $nick :Utilisateur inconnu."
}

proc cs::delmask {nick host hand chan arg} {
 variable level
 variable chan-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(delmask)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 delmask "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {[llength $arg]!=2} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick DELMASK <#salon> <pseudo> <host/mask>"
    return
  }
  set n [lindex $arg 0]
  set h [lindex $arg 1]
  if ![string match *!*@* $h] {
    putserv "NOTICE $nick :Mask invalide."
    return
  }
  set x 0
  set z 1
  foreach d [set chan-data($chan)] {
    if {[lindex $d 0]=="ACCESS" && [stgcomp $n [lindex $d 1]]} {
      set z 0
      set y 0
      foreach m $d {
        if [stgcomp $m $h] {
          lset chan-data($chan) $x [join [lreplace [lindex [set chan-data($chan)] $x] $y $y]]
          putserv "NOTICE $nick :Mask supprim."
          dolog 1 delmask "$nick@[nick2hand $nick $chan] $chan $arg"
          return
        }
        incr y
      }
    }
    incr x
  }
  if $z {
    putserv "NOTICE $nick :Utilisateur inconnu."
  } else {
    putserv "NOTICE $nick :Mask inconnu."
  }
}

proc cs::addmask {nick host hand chan arg} {
 variable level
 variable chan-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(addmask)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 addmask "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {[llength $arg]!=2} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick ADDMASK <#salon> <pseudo> <host/mask>"
    return
  }
  set n [lindex $arg 0]
  set h [lindex $arg 1]
  if ![string match *!*@* $h] {
    putserv "NOTICE $nick :Mask invalide."
    return
  }
  if {[string length $h]<8} {
    putserv "NOTICE $nick :le mask est trop imprcis, minimum 8 caratres."
    return
  }
  set x 0
  foreach d [set chan-data($chan)] {
    if {[lindex $d 0]=="ACCESS" && [stgcomp $n [lindex $d 1]]} {
      foreach m [lrange $d 8 end] {
        if [hostcomp $m $h] {
          putserv "NOTICE $nick :Ce mask xiste dj."
          return
        }
      }
      lset chan-data($chan) $x [join [linsert [lindex [set chan-data($chan)] $x] end $h]]
      putserv "NOTICE $nick :Mask ajout."
      dolog 1 addmask "$nick@[nick2hand $nick $chan] $chan $arg"
      return
    }
    incr x
  }
  putserv "NOTICE $nick :Utilisateur inconnu."
}

proc cs::chmodeslevel {nick host hand chan arg} {
 variable level
 variable chan-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(chmodeslevel)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 chmodeslevel "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {[llength $arg]!=1 || ![string is digit $arg]} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick CHMODESLEVEL <#salon> <level>"
    return
  }
  set x -1
  set a [set chan-data($chan)]
  while {$x<[llength $a]} {
    incr x
    if {[lindex $a $x 0]=="CHMODESLEVEL"} {
      lset chan-data($chan) $x 1 $arg
      putserv "NOTICE $nick :L'option  t modifie."
      dolog 1 chmodeslevel "$nick@[nick2hand $nick $chan] $chan $arg"
      return
    }
  }
  lappend chan-data($chan) [list CHMODESLEVEL $arg]
  putserv "NOTICE $nick :L'option  t modifie."
  dolog 1 chmodeslevel "$nick@[nick2hand $nick $chan] $chan $arg"
}

proc cs::banlevel {nick host hand chan arg} {
 variable level
 variable chan-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(banlevel)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 banlevel "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {[llength $arg]!=1 || ![string is digit $arg]} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick BANLEVEL <#salon> <level>"
    return
  }
  set x -1
  set a [set chan-data($chan)]
  while {$x<[llength $a]} {
    incr x
    if {[lindex $a $x 0]=="BANLEVEL"} {
      lset chan-data($chan) $x 1 $arg
      putserv "NOTICE $nick :L'option  t modifie."
      dolog 1 banlevel "$nick@[nick2hand $nick $chan] $chan $arg"
      return
    }
  }
  lappend chan-data($chan) [list BANLEVEL $arg]
  putserv "NOTICE $nick :L'option  t modifie."
  dolog 1 banlevel "$nick@[nick2hand $nick $chan] $chan $arg"
}

proc cs::bantimeout {nick host hand chan arg} {
 variable level
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(bantimeout)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 bantimeout "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {$arg=="" || (![string is digit [lindex $arg 0]] && ![stgcomp [lindex $arg 0] "off"])} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick BANTIMEOUT <#salon> <dure/off>"
    return
  }
  if {[lindex $arg 0]=="off"} {set arg 0}
  channel set $chan ban-time [lindex $arg 0]
  dolog 1 bantimeout "$nick@[nick2hand $nick $chan] $chan $arg"
  if {[lindex $arg 0]==0} {
    putserv "NOTICE $nick :Le mode bantimeout est dsactiv."
  } else {
    putserv "NOTICE $nick :Le mode bantimeout  t modifi ([lindex $arg 0] minutes)."
  }
}

proc cs::showcommands {nick host hand chan arg} {
 variable level
  set var ""
  set x 0
  putquick "NOTICE $nick :\026\002Commande\002 \[\002Accs\002\] \002Commande\002 \[\002Accs\002\] "
  foreach "a b" [array get level] {
    if {[getlevel [nick2hand $nick $chan] $chan]>=$b} {
      lappend var "\002[string toupper $a]\002 \[\002$b\002\]"
      incr x
    } 
    if {$x==2} {
      putnow "NOTICE $nick :[join $var]"
      set var ""
      set x 0
    } 
  }
  if {$var!=""} {
    putnow "NOTICE $nick :[join $var]"
  }
  dolog 1 showcommands "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::chaninfo {nick host hand chan arg} {
 variable level
 variable chan-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(chaninfo)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 chaninfo "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if ![info exists chan-data($chan)] {
    putquick "NOTICE $nick :Salon invalide."
    return
  }
  set x -1
  set nba 0
  set a [set chan-data($chan)]
  while {$x<[llength $a]} {
    incr x
    if {[lindex $a $x 0]=="ACCESS"} {
      incr nba
      if {[lindex $a $x 3]==500} {
        set ownernick [lindex $a $x 1]
      }
      continue
    }
    if {[lindex $a $x 0]=="CREATE"} {
      set create [exptime [lindex $a $x 1]]
      continue
    }
    if {[lindex $a $x 0]=="TOPIC"} {
      set deftopic [lrange [lindex $a $x] 1 end]
      continue
    }
    if {[lindex $a $x 0]=="WELCOME"} {
      set welcome [lrange [lindex $a $x] 1 end]
      continue
    }
    if {[lindex $a $x 0]=="CHMODESLEVEL"} {
      set chmodeslevel [lindex $a $x 1]
      continue
    }
    if {[lindex $a $x 0]=="BANLEVEL"} {
      set banlevel [lindex $a $x 1]
      continue
    }
    if {[lindex $a $x 0]=="DESCRIPTION"} {
      set description [lrange [lindex $a $x] 1 end]
      continue
    }
    if {[lindex $a $x 0]=="CHANURL"} {
      set chanurl [lindex $a $x 1]
      continue
    }
  }
  set defmodes [channel get $chan chanmode]
  set bantimeout [channel get $chan ban-time]
  if [channel get $chan noop] {set noop \00303OUI\003} else {set noop \00304NON\003}
  if [channel get $chan noban] {set noban \00303OUI\003} else {set noban \00304NON\003}
  if [channel get $chan strictop] {set strictop \00303OUI\003} else {set strictop \00304NON\003}
  if [channel get $chan autoops] {set autoops \00303OUI\003} else {set autoops \00304NON\003}
  if [channel get $chan locktopic] {set locktopic \00303OUI\003} else {set locktopic \00304NON\003}
  if [channel get $chan setwelcome] {set setwelcome \00303OUI\003} else {set setwelcome \00304NON\003}
  if [channel get $chan setvoice] {set setvoice \00303OUI\003} else {set setvoice \00304NON\003}
  if [channel get $chan lockmodes] {set lockmodes \00303OUI\003} else {set lockmodes \00304NON\003}
  if [channel get $chan strictmodes] {set strictmodes \00303OUI\003} else {set strictmodes \00304NON\003}
  if ![info exists deftopic] {set deftopic "Aucun topic par dfaut"}
  if ![info exists welcome] {set welcome "Pas de message d'accueille dfini"}
  if ![info exists chmodeslevel] {set chmodeslevel $level(mode)}
  if ![info exists banlevel] {set banlevel $level(ban)}
  if ![info exists ownername] {set ownername "Non dfini"}
  if ![info exists ownernick] {set ownernick "Non dfini"}
  if ![info exists ownermail] {set ownermail "Non dfini"}
  if ![info exists description] {set description "Aucune dscription dfinie"}
  if ![info exists chanurl] {set chanurl "Non dfini"}

  putquick "NOTICE $nick : Information sur 4[join $chan] "
  putquick "NOTICE $nick : OwnerName:2 [join $ownername]"
  putquick "NOTICE $nick : OwnerNick:2  [join $ownernick]"
  putquick "NOTICE $nick : OwnerMail:2  [join $ownermail]"
  putquick "NOTICE $nick : ChanUrl:2  [join $chanurl]"
  putquick "NOTICE $nick : Message d'accueille: [join $welcome]"
  putquick "NOTICE $nick : Topic par dfaut:  [join $deftopic]"
  putquick "NOTICE $nick : Modes par dfaut:  [join $defmodes]"
  putquick "NOTICE $nick : Description du salon:  [join $description]"
  putquick "NOTICE $nick : 14Options du Salon  "
  putquick "NOTICE $nick : Noop: $noop  Noban: $noban  Strictop: $strictop  "
  putquick "NOTICE $nick : Lockmodes: $lockmodes  Autoops: $autoops  Locktopic: $locktopic  "
  putquick "NOTICE $nick : Setwelcome: $setwelcome  Setvoice: $setvoice  Strictmodes: $strictmodes  "
  putquick "NOTICE $nick : Chmodeslevel:10 $chmodeslevel  Banlevel:10 $banlevel  Bantimeout:10 $bantimeout  "
  putquick "NOTICE $nick : $nba Accs cr sur 14[join $chan] "
  if [info exists create] {putquick "NOTICE $nick : Channel cr le $create "}
  dolog 1 chaninfo "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::rdefaults {nick host hand chan arg} {
 variable level
 variable chan-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(rdefaults)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 rdefaults "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  set x 0
  set topic ""
  foreach a [set chan-data($chan)] {
    if {[lindex $a 0]!="TOPIC"} {incr x;continue}
    set topic [lrange $a 1 end]
    break
  }
  if {$topic==""} {
    putserv "NOTICE $nick :Aucun topic par dfaut dfini."
  } else {
    if ![channel get $chan locktopic] {
      putserv "NOTICE $nick :Topic par dfaut rtabli."
      putquick "TOPIC $chan :[join $topic]"
    } else {
      putquick "NOTICE $nick :Le mode locktopic est activ."
    }
  }
  putquick "MODE $chan [string map {+ - - +} [getchanmode $chan]]"
  putquick "MODE $chan [channel get $chan chanmode]"
  putserv "NOTICE $nick :Modes par dfaut rtablis."
  dolog 1 rdefaults "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::rdeftopic {nick host hand chan arg} {
 variable level
 variable chan-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(rdeftopic)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 rdeftopic "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  set x 0
  set topic ""
  foreach a [set chan-data($chan)] {
    if {[lindex $a 0]!="TOPIC"} {incr x;continue}
    set topic [lrange $a 1 end]
    break
  }
  if {$topic==""} {
    putserv "NOTICE $nick :Aucun topic par dfaut dfini."
  } else {
    if ![channel get $chan locktopic] {
      putserv "NOTICE $nick :Topic par dfaut rtabli."
      putquick "TOPIC $chan :[join $topic]"
    } else {
      putquick "NOTICE $nick :Le mode locktopic est activ."
      return
    }
  }
  dolog 1 rdeftopic "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::deftopic {nick host hand chan arg} {
 variable level
 variable chan-data
  set chan [string tolower $chan]
  set arg [split $arg]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(deftopic)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 deftopic "$nick@[nick2hand $nick $chan] $chan [join $arg]"
    return
  }
  if {$arg==""} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick DEFTOPIC <#salon> <texte>"
    return
  }
  set x 0
  set y 0
  foreach a [set chan-data($chan)] {
    if {[lindex $a 0]!="TOPIC"} {incr x;continue}
    incr y
    break
  }
  if !$y {
    lappend chan-data($chan) [list TOPIC [join $arg]]
  } else {
    set chan-data($chan) [lreplace [set chan-data($chan)] $x $x [list TOPIC [join $arg]]]
  }
  putserv "NOTICE $nick :Topic par dfaut modifi."
  if ![channel get $chan locktopic] {
    putquick "TOPIC $chan :[join $arg]"
  } else {
    putquick "NOTICE $nick :Le mode locktopic est activ."
  }
  dolog 1 deftopic "$nick@[nick2hand $nick $chan] $chan [join $arg]"
}

proc cs::topic {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(topic)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 topic "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {$arg==""} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick TOPIC <#salon> <texte>"
    return
  }
  if [channel get $chan locktopic] {
    putquick "NOTICE $nick :Le mode locktopic est activ."
    return
  }
  putserv "TOPIC $chan :$arg"
  dolog 1 topic "$nick@[nick2hand $nick $chan] $chan $arg"
}

proc cs::moderate {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(moderate)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 moderate "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  putquick "MODE $chan +m"
  cs::pushmode $chan +v [::chanlist $chan]
  dolog 1 moderate "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::say {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(say)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 say "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {$arg==""} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick SAY <#salon> <texte>"
    return
  }
  putserv "PRIVMSG $chan :$arg"
  dolog 1 say "$nick@[nick2hand $nick $chan] $chan $arg"
}

proc cs::do {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(do)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 do "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {$arg==""} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick DO <#salon> <texte>"
    return
  }
  putserv "PRIVMSG $chan :\001ACTION $arg\001"
  dolog 1 do "$nick@[nick2hand $nick $chan] $chan $arg"
}

proc cs::Pchanlist {nick host hand chan arg} {
  cs::chanlist $nick $host $hand $arg
}

proc cs::chanlist {nick host hand arg} {
 variable level
 variable chan-data
  set chan [lindex $arg 0]
  if {[getlevel [nick2hand $nick]]<$level(chanlist)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 chanlist "$nick@[nick2hand $nick]"
    return
  }
  set x 0
  putquick "NOTICE $nick : Liste des salons "
  foreach chan [string tolower [channels]] {
    if ![info exists chan-data($chan)] continue
    incr x
    unset -nocomplain admin create
    foreach a [set chan-data($chan)] {
      if {[lindex $a 0]=="ACCESS" && [lindex $a 3]=="500"} {
        set admin [lindex $a 1]
      }
      if {[lindex $a 0]=="CREATE"} {
        set create [list [exptime [lindex $a 1]] [lindex $a 2]]
      }
      if {[info exists admin] && [info exists create]} {
        putquick "NOTICE $nick :\00301\002$chan\002  \037Owner\037: \00302$admin\003"
        putquick "NOTICE $nick :\00301\037cr\037 \037le\037: \00314[lindex $create 0]\00301 \037par\037: \00310[lindex $create 1]\003"
        break
      }
    }
  }
  putquick "NOTICE $nick : Nombre de salons - \002\00304$x\002\003 "
  dolog 1 chanlist "$nick@[nick2hand $nick]"
}

proc cs::clearmodes {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(clearmodes)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 clearmodes "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if [channel get $chan lockmodes] {
    putquick "NOTICE $nick :Le mode lockmodes est activ."
    return
  }
  putquick "MODE $chan [string map {+ - - +} [getchanmode $chan]]"
  putserv "NOTICE $nick :Modes supprims."
  dolog 1 clearmodes "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::rdefmodes {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(rdefmodes)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 rdefmodes "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if [channel get $chan lockmodes] {
    putquick "NOTICE $nick :Le mode lockmodes est activ."
    return
  }
  putquick "MODE $chan [string map {+ - - +} [getchanmode $chan]]"
  putquick "MODE $chan [channel get $chan chanmode]"
  putserv "NOTICE $nick :Modes par dfaut rtablis."
  dolog 1 rdefmodes "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::defmodes {nick host hand chan arg} {
 variable level
 variable chan-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(defmodes)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 defmodes "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {$arg==""} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick DEFMODES <#salon> <+/-modes> <options>"
    return
  }
  if [channel get $chan lockmodes] {
    putquick "NOTICE $nick :Le mode lockmodes est activ."
    return
  }
  set mode [lindex $arg 0]
  set opt [lrange $arg 1 end]
  channel set $chan chanmode [list $mode [join $opt]]
  putquick "MODE $chan $mode [join $opt]"
  putserv "NOTICE $nick :Modes par dfaut modifis."
  dolog 1 defmodes "$nick@[nick2hand $nick $chan] $chan $arg"
}

proc cs::mode {nick host hand chan arg} {
 variable level
 variable chan-data
  set chan [string tolower $chan]
  foreach a [set chan-data($chan)] {
    if {[lindex $a 0]=="CHMODESLEVEL"} {
      set chlevel [lindex $a 1]
      break
    }
  }
  if ![info exists chlevel] {set chlevel $level(mode)}
  if {[getlevel [nick2hand $nick $chan] $chan]<$chlevel} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 mode "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {$arg==""} {
    putquick "NOTICE $nick :Syntaxe: /msg $::botnick MODE <#salon> <+/-modes> <options>"
    return
  }
  if [channel get $chan lockmodes] {
    putquick "NOTICE $nick :Le mode lockmodes est activ."
    return
  }
  set mode [lindex $arg 0]
  set opt [lrange $arg 1 end]
  foreach bm "o v b" {
    if [string match *$bm* $mode] {
      putquick "NOTICE $nick :Le mode $bm est interdit."
      return
    }
  }
  putquick "MODE $chan $mode [join $opt]"
  dolog 1 mode "$nick@[nick2hand $nick $chan] $chan $arg"
}

proc cs::voiceall {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(voiceall)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 voiceall "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  cs::pushmode $chan +v [::chanlist $chan]
  dolog 1 voiceall "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::devoiceall {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(devoiceall)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 devoiceall "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  cs::pushmode $chan -v [::chanlist $chan]
  dolog 1 devoiceall "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::opall {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(opall)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 opall "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  cs::pushmode $chan +o [::chanlist $chan]
  dolog 1 opall "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::deopall {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(deopall)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 deopall "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  cs::pushmode $chan -o [::chanlist $chan]
  dolog 1 deopall "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::strictop {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(strictop)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 strictop "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if [channel get $chan strictop] {
    channel set $chan -strictop
    putserv "NOTICE $nick :Le mode strictop est dsactiv."
    dolog 1 strictop "$nick@[nick2hand $nick $chan] $chan dsactiv"
  } else {
    channel set $chan +strictop
    putserv "NOTICE $nick :Le mode strictop est activ."
    dolog 1 strictop "$nick@[nick2hand $nick $chan] $chan activ"
  }
}

proc cs::autoops {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(autoops)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 autoops "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if [channel get $chan autoops] {
    channel set $chan -autoops
    putserv "NOTICE $nick :Le mode autoops est dsactiv."
    dolog 1 autoops "$nick@[nick2hand $nick $chan] $chan dsactiv"
  } else {
    channel set $chan +autoops
    putserv "NOTICE $nick :Le mode autoops est activ."
    dolog 1 autoops "$nick@[nick2hand $nick $chan] $chan activ"
  }
}

proc cs::setvoice {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(setvoice)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 setvoice "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if [channel get $chan setvoice] {
    channel set $chan -setvoice
    putserv "NOTICE $nick :Le mode setvoice est dsactiv."
    dolog 1 setvoice "$nick@[nick2hand $nick $chan] $chan dsactiv"
  } else {
    channel set $chan +setvoice
    putserv "NOTICE $nick :Le mode setvoice est activ."
    dolog 1 setvoice "$nick@[nick2hand $nick $chan] $chan activ"
  }
}

proc cs::strictmodes {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(strictmodes)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 strictmodes "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if [channel get $chan strictmodes] {
    channel set $chan -strictmodes
    putserv "NOTICE $nick :Le mode strictmodes est dsactiv."
    dolog 1 strictmodes "$nick@[nick2hand $nick $chan] $chan dsactiv"
  } else {
    channel set $chan +strictmodes
    putserv "NOTICE $nick :Le mode strictmodes est activ."
    dolog 1 strictmodes "$nick@[nick2hand $nick $chan] $chan activ"
  }
}

proc cs::lockmodes {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(lockmodes)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 lockmodes "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if [channel get $chan lockmodes] {
    channel set $chan -lockmodes
    putserv "NOTICE $nick :Le mode lockmodes est dsactiv."
    dolog 1 lockmodes "$nick@[nick2hand $nick $chan] $chan dsactiv"
  } else {
    channel set $chan +lockmodes
    putserv "NOTICE $nick :Le mode lockmodes est activ."
    dolog 1 lockmodes "$nick@[nick2hand $nick $chan] $chan activ"
  }
}

proc cs::locktopic {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(locktopic)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 locktopic "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if [channel get $chan locktopic] {
    channel set $chan -locktopic
    putserv "NOTICE $nick :Le mode locktopic est dsactiv."
    dolog 1 locktopic "$nick@[nick2hand $nick $chan] $chan dsactiv"
  } else {
    channel set $chan +locktopic
    putserv "NOTICE $nick :Le mode locktopic est activ."
    dolog 1 locktopic "$nick@[nick2hand $nick $chan] $chan activ"
  }
}

proc cs::noop {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(noop)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 noop "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if [channel get $chan noop] {
    channel set $chan -noop
    putserv "NOTICE $nick :Le mode noop est dsactiv."
    dolog 1 noop "$nick@[nick2hand $nick $chan] $chan dsactiv"
  } else {
    channel set $chan +noop
    putserv "NOTICE $nick :Le mode noop est activ."
    dolog 1 noop "$nick@[nick2hand $nick $chan] $chan activ"
  }
}

proc cs::noban {nick host hand chan arg} {
 variable level
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(noban)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 noban "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  if [channel get $chan noban] {
    channel set $chan -noban
    putserv "NOTICE $nick :Le mode noban est dsactiv."
    dolog 1 noban "$nick@[nick2hand $nick $chan] $chan dsactiv"
  } else {
    channel set $chan +noban
    putserv "NOTICE $nick :Le mode noban est activ."
    dolog 1 noban "$nick@[nick2hand $nick $chan] $chan activ"
  }
}

proc cs::Prehash {nick host hand chan arg} {
  cs::rehash $nick $host $hand $arg
}

proc cs::rehash {nick host hand arg} {
 variable level
  if {[getlevel [nick2hand $nick]]<$level(rehash)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 rehash "$nick@[nick2hand $nick]"
    return
  }
  if [catch {eval ::rehash} error] {
    putserv "NOTICE $nick :$error"
  } else {
    putserv "NOTICE $nick :Rehash ok."
  }
    dolog 1 rehash "$nick@[nick2hand $nick]"
}

proc cs::Prestart {nick host hand chan arg} {
  cs::restart $nick $host $hand $arg
}

proc cs::restart {nick host hand arg} {
 variable level
  if {[getlevel [nick2hand $nick]]<$level(restart)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 restart "$nick@[nick2hand $nick]"
    return
  }
  putquick "QUIT :Restart ([nick2hand $nick])"
  ::restart
}

proc cs::clearbans {nick host hand chan arg} {
 variable chan-data
 variable level
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(clearbans)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 clearbans "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  set l ""
  foreach a [chanbans $chan] {
    if {[lsearch $l [lindex $a 0]]!="-1"} continue
    lappend l [join [lindex $a 0]]
  }
  if {$l!=""} {pushmode $chan -b [join $l]}

  set x 0
  while {$x<[llength [set chan-data($chan)]]} {
    if {[lindex [set chan-data($chan)] $x 0]!="BAN"} {incr x;continue}
    set l 1
    set chan-data($chan) [lreplace [set chan-data($chan)] $x $x]
  }
  if {$l==""} {putserv "NOTICE $nick :Aucun ban pour $chan."} else {putserv "NOTICE $nick :Banliste vide."}
  dolog 1 clearbans "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::unban {nick host hand chan arg} {
 variable chan-data
 variable level
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(unban)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 unban "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
    return
  }
  if {[llength $arg]!=1} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick UNBAN <#salon> <host/mask>"
    return
  }
  set x 0
  foreach a [set chan-data($chan)] {
    if {[lindex $a 0]!="BAN"} {incr x;continue}
    if [stgcomp [lindex $a 1] [lindex $arg 0]] {
      putquick "MODE $chan -b [join [lindex $arg 0]]"
      putserv "NOTICE $nick :Ban supprim."
      set chan-data($chan) [lreplace [set chan-data($chan)] $x $x]
      dolog 1 unban "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
      return
    }
    incr x
  }
  foreach a [chanbans $chan] {
    if [stgcomp [lindex $a 0] [lindex $arg 0]] {
      putquick "MODE $chan -b [join [lindex $arg 0]]"
      putserv "NOTICE $nick :Ban supprim."
      dolog 1 unban "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
      return
    }
  }
  putserv "NOTICE $nick :Aucun ban correspondant."
}

proc cs::banlist {nick host hand chan arg} {
 variable chan-data
 variable level
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(banlist)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 banlist "$nick@[nick2hand $nick $chan] $chan"
    return
  }
  set z 0
  foreach a [set chan-data($chan)] {
    if {[lindex $a 0]!="BAN"} {continue}
    if !$z {
      putquick "NOTICE $nick : Banlist sur 14$chan "
      putquick "NOTICE $nick :Host/mask  Expiration  Raisons"
      set z 1
    }
    if ![lindex $a 3] {
      putquick "NOTICE $nick :[join [lindex $a 1]]  Permanant  [join [lrange $a 5 end]]"
    } else {
      putquick "NOTICE $nick :[join [lindex $a 1]]  [exptime [lindex $a 3]]  [join [lrange $a 5 end]]"
    }
  }
  if $z {
    putquick "NOTICE $nick : Fin de liste "
  } else {
    putquick "NOTICE $nick :Banlist vide."
  }
  dolog 1 banlist "$nick@[nick2hand $nick $chan] $chan"
}

proc cs::kick {nick host hand chan arg} {
 variable level
 variable kickraison
  set chan [string tolower $chan]
  set n [lindex $arg 0]
  if {[set raison [lrange $arg 1 end]]==""} {set raison $kickraison}
  if {[getlevel [nick2hand $nick $chan] $chan]>=$level(kick)} {
    if {$n==""} {putserv "NOTICE $nick :Syntaxe: /msg $::botnick KICK <#salon> <pseudo> <raison>";return}
    if {[getlevel [nick2hand $nick $chan] $chan]<=[getlevel [nick2hand $n $chan] $chan]} {
      putserv "NOTICE $nick :Votre niveau est insufisent pour kicker [hand2nick [nick2hand $n $chan] $chan]."
    } else {
      putquick "KICK $chan [join $n] :[join $raison]"
      putserv "NOTICE @$chan :$::botnick a kick [join $n] sur $chan ([join $raison] \[\002$nick\002\])"
      dolog 1 kick "$nick@[nick2hand $nick $chan] $chan $n :$raison"
    }
  } else {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 kick "$nick@[nick2hand $nick $chan] $chan $n :$raison"
  }
}

proc cs::kickban {nick host hand chan arg} {
 variable chan-data
 variable level
  set chan [string tolower $chan]
  foreach a [set chan-data($chan)] {
    if {[lindex $a 0]=="BANLEVEL"} {
      set banlevel [lindex $a 1]
      break
    }
  }
  if {![info exists banlevel] || $banlevel<$level(kickban)} {set banlevel $level(kickban)}
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(kickban)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 kickban "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
    return
  }
  if {[llength $arg]<1} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick KICKBAN <#salon> <pseudo> <raison>"
    return
  }
  set n [lindex $arg 0]
  if {[set r [lrange $arg 1 end]]==""} {set r "Indsirable"}
  if ![onchan $n $chan] {
    putserv "NOTICE $nick :Ce pseudo n'est pas prsent sur $chan."
    return
  }
  if {[getlevel [nick2hand $nick $chan] $chan]<=[getlevel [nick2hand $n $chan] $chan]} {
    putserv "NOTICE $nick :Impossible de bannir ce pseudo."
    return
  }
  if [channel get $chan noban] {
    putquick "NOTICE $nick :Le mode noban est activ."
    return
  }
  set mask *!*@[lindex [split [getchanhost $n $chan] @] end]
  set x 0
  foreach a [set chan-data($chan)] {
    if {[lindex $a 0]!="BAN"} {continue}
    if [stgcomp [lindex $a 1] $mask] {
      set x 1;break
    }
  }
  putquick "MODE $chan +b [join $mask]"
  putquick "KICK $chan [join $n] :[join $r]"
  putserv "NOTICE @$chan :$::botnick a kick [join $n] sur $chan ([join $r] \[\002$nick\002\])"
  if !$x {
    lappend chan-data($chan) "BAN [join $mask] [join [nick2hand $nick $chan]] [expr [unixtime]+1600] [unixtime] [join $r]"
  }
  putserv "NOTICE $nick :Kickan effectu."
  dolog 1 kickban "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
}

proc cs::ban {nick host hand chan arg} {
 variable chan-data
 variable level
  set chan [string tolower $chan]
  foreach a [set chan-data($chan)] {
    if {[lindex $a 0]=="BANLEVEL"} {
      set banlevel [lindex $a 1]
      break
    }
  }
  if ![info exists banlevel] {set banlevel $level(ban)}
  if {[getlevel [nick2hand $nick $chan] $chan]<$banlevel} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 ban "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
    return
  }
  if {[llength $arg]<1} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick BAN <#salon> <host/mask> <dure en minutes> <raison>"
    return
  }
  if [channel get $chan noban] {
    putquick "NOTICE $nick :Le mode noban est activ."
    return
  }
  set h [lindex $arg 0]
  if ![string match *!*@* $h] {
    putserv "NOTICE $nick :Mask invalide."
    return
  }
  if {[string length $h]<6} {
    putserv "NOTICE $nick :le mask est trop imprcis, minimum 6 caratres."
    return
  }
  set d [lindex $arg 1]
  set r [lrange $arg 2 end]
  if {![string is digit $d] || $d==""} {
    set d 20
    if {[set r [lrange $arg 1 end]]==""} {set r "Indsirable"}
  }
  foreach a [set chan-data($chan)] {
    if {[lindex $a 0]!="BAN"} {continue}
    if [stgcomp [lindex $a 1] [lindex $arg 0]] {
      putserv "NOTICE $nick :Ce ban xiste dj."
      return
    }
  }
  foreach n [host2nick $h $chan] {
    if {[getlevel [nick2hand $n $chan] $chan]>=[getlevel [nick2hand $nick $chan] $chan]} {
      putserv "NOTICE $nick :Impossible de bannir ce mask."
      return
    }
  }
  putquick "MODE $chan +b [lindex $arg 0]"
  if {$d==0} {
    lappend chan-data($chan) "BAN [join $h] [join [nick2hand $nick $chan]] 0 [unixtime] [join $r]"
  } else {
    lappend chan-data($chan) "BAN [join $h] [join [nick2hand $nick $chan]] [expr [unixtime]+(60*$d)] [unixtime] [join $r]"
  }
  putserv "NOTICE $nick :Ban ajout."
  dolog 1 ban "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
}

proc cs::Pdeladmin {nick host hand chan arg} {
  cs::deladmin $nick $host $hand $arg
}

proc cs::deladmin {nick host hand arg} {
 variable admin-data
 variable auth
 variable level
  if {[getlevel [nick2hand $nick]]<$level(deladmin)} {
    putserv "NOTICE $nick :Accs refus."
    dolog 0 deladmin "$nick@[nick2hand $nick] $arg"
    return
  }
  if {[llength $arg]!=1} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick DELADMIN <username/login>"
    return
  }
  set n [lindex $arg 0]
  set x 0
  set y 0
  while {$x<[llength [set admin-data]]} {
    if {[lindex [set admin-data] $x 0]!="ACCESS" && [lindex [set admin-data] $x 0]!="INFO" && [lindex [set admin-data] $x 0]!="SEEN"} {incr x;continue}
    if [stgcomp [lindex [set admin-data] $x 1] $n] {
      if {[lindex [set admin-data] $x 0]=="ACCESS"} {
        if {[getlevel [nick2hand $nick]]<=[lindex [set admin-data] $x 3]} {
          putserv "NOTICE $nick :Impossible de supprimer cet utilisateur."
          return
        }
        unset -nocomplain auth([string tolower $n],*)
        set admin-data [lreplace [set admin-data] $x $x]
        set y 1
        continue
      }
      if {[lindex [set admin-data] $x 0]=="INFO"} {
        set admin-data [lreplace [set admin-data] $x $x]
        continue
      }
      if {[lindex [set admin-data] $x 0]=="SEEN"} {
        set admin-data [lreplace [set admin-data] $x $x]
        continue
      }
    }
    incr x
  }
  if !$y {
    putserv "NOTICE $nick :Utilisateur inconnu."
  } else {
    putserv "NOTICE $nick :Utilisateur supprim."
    dolog 1 deladmin "$nick@[nick2hand $nick] $n"
    write admin
  }
}

proc cs::addadmin {nick host hand arg} {
 variable admin-data
 variable auth
 variable level
  if {[getlevel [nick2hand $nick]]<$level(addadmin)} {
    putserv "NOTICE $nick :Accs refus."
    dolog 0 addadmin "$nick@[nick2hand $nick]"
    return
  }
  if {[llength $arg]!=4} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick ADDADMIN <username/login> <mask/host> <level> <mot_de_passe>"
    return
  }
  set n [lindex $arg 0]
  set h [lindex $arg 1]
  if ![string match *!*@* $h] {
    putserv "NOTICE $nick :Mask invalide."
    return
  }
  if {[string length $h]<8} {
    putserv "NOTICE $nick :le mask est trop imprcis, minimum 8 caratres."
    return
  }
  set lv [lindex $arg 2]
  if ![string is digit $lv] {
    putserv "NOTICE $nick :Level invalide."
    return
  }
  if {$lv>=[getlevel [nick2hand $nick]]} {
    putserv "NOTICE $nick :Vous ne pouvez pas ajouter un level superieur ou gale au votre."
    return
  }
  if {[string length [set pw [lindex $arg 3]]]<6} {
    putserv "NOTICE $nick :Le mot de passe doit contenir au moin 6 caractres."
    return
  }
  foreach a [set admin-data] {
    if {[lindex $a 0]!="ACCESS"} {continue}
    if [stgcomp [lindex $a 1] $n] {
      putserv "NOTICE $nick :Ce pseudo est dj enregistr."
      return
    }
  }
  lappend admin-data "ACCESS [join $n] [join $pw] $lv 0 0 1 0 [join $h]"
  write admin
  putserv "NOTICE $nick :Utilisateur ajout avec succs."
  dolog 1 addadmin "$nick@[nick2hand $nick] $n ($lv)"
}

proc cs::Pdeluser {nick host hand chan arg} {
  set arg "$chan $arg"
  cs::deluser $nick $host $hand [join $arg]
}

proc cs::deluser {nick host hand arg} {
 variable chan-data
 variable auth
 variable level
  set c [string tolower [lindex $arg 0]]
  if {[getlevel [nick2hand $nick $c] $c]<$level(deluser)} {
    putserv "NOTICE $nick :Accs refus."
    dolog 0 deluser "$nick@[nick2hand $nick $c] $arg"
    return
  }
  if {[llength $arg]!=2} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick DELUSER <#salon> <username/login>"
    return
  }
  if {![validchan $c] || ![info exists chan-data($c)]} {
    putserv "NOTICE $nick :Salon invalide."
    return
  }
  set n [lindex $arg 1]
  set x 0
  set y 0
  while {$x<[llength [set chan-data($c)]]} {
    if {[lindex [set chan-data($c)] $x 0]!="ACCESS" && [lindex [set chan-data($c)] $x 0]!="INFO" && [lindex [set chan-data($c)] $x 0]!="SEEN"} {incr x;continue}
    if [stgcomp [lindex [set chan-data($c)] $x 1] $n] {
      if {[lindex [set chan-data($c)] $x 0]=="ACCESS"} {
        if {[getlevel [nick2hand $nick $c] $c]<=[lindex [set chan-data($c)] $x 3]} {
          putserv "NOTICE $nick :Impossible de supprimer cet utilisateur."
          return
        }
        unset -nocomplain auth([string tolower $n],$c)
        set chan-data($c) [lreplace [set chan-data($c)] $x $x]
        set y 1
        continue
      }
      if {[lindex [set chan-data($c)] $x 0]=="INFO"} {
        set chan-data($c) [lreplace [set chan-data($c)] $x $x]
        continue
      }
      if {[lindex [set chan-data($c)] $x 0]=="SEEN"} {
        set chan-data($c) [lreplace [set chan-data($c)] $x $x]
        continue
      }
    }
    incr x
  }
  if !$y {
    putserv "NOTICE $nick :Utilisateur inconnu."
  } else {
    putserv "NOTICE $nick :Utilisateur supprim."
    dolog 1 deluser "$nick@[nick2hand $nick $c] $c $n"
    write $c
  }
}

proc cs::adduser {nick host hand arg} {
 variable chan-data
 variable auth
 variable level
  set c [string tolower [lindex $arg 0]]
  if {[getlevel [nick2hand $nick $c] $c]<$level(adduser)} {
    putserv "NOTICE $nick :Accs refus."
    dolog 0 adduser "$nick@[nick2hand $nick $c]"
    return
  }
  if {[llength $arg]!=8} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick ADDUSER <#salon> <username/login> <mask/host> <level> <autoop(ON/OFF)>  <protect(ON/OFF)>  <voice(ON/OFF)> <mot_de_passe>"
    return
  }
  if {![validchan $c] || ![info exists chan-data($c)]} {
    putserv "NOTICE $nick :Salon invalide."
    return
  }
  set n [lindex $arg 1]
  set h [lindex $arg 2]
  if ![string match *!*@* $h] {
    putserv "NOTICE $nick :Mask invalide."
    return
  }
  if {[string length $h]<8} {
    putserv "NOTICE $nick :le mask est trop imprcis, minimum 8 caratres."
    return
  }
  set lv [lindex $arg 3]
  if ![string is digit $lv] {
    putserv "NOTICE $nick :Level invalide."
    return
  }
  if {$lv>=[getlevel [nick2hand $nick $c] $c]} {
    putserv "NOTICE $nick :Vous ne pouvez pas ajouter un level superieur ou gale au votre."
    return
  }
  if [stgcomp [lindex $arg 4] on] {
    set ao 1
  } elseif [stgcomp [lindex $arg 4] off] {
    set ao 0
  } else {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick ADDUSER <#salon> <username/login> <mask/host> <level> <autoop(ON/OFF)>  <protect(ON/OFF)>  <voice(ON/OFF)> <mot_de_passe>"
    return
  }
  if [stgcomp [lindex $arg 5] on] {
    set pr 1
  } elseif [stgcomp [lindex $arg 5] off] {
    set pr 0
  } else {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick ADDUSER <#salon> <username/login> <mask/host> <level> <autoop(ON/OFF)>  <protect(ON/OFF)>  <voice(ON/OFF)> <mot_de_passe>"
    return
  }
  if [stgcomp [lindex $arg 6] on] {
    set av 1
  } elseif [stgcomp [lindex $arg 6] off] {
    set av 0
  } else {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick ADDUSER <#salon> <username/login> <mask/host> <level> <autoop(ON/OFF)>  <protect(ON/OFF)>  <voice(ON/OFF)> <mot_de_passe>"
    return
  }
  if {[string length [set pw [lindex $arg 7]]]<6} {
    putserv "NOTICE $nick :Le mot de passe doit contenir au moin 6 caractres."
    return
  }
  foreach a [set chan-data($c)] {
    if {[lindex $a 0]!="ACCESS"} {continue}
    if [stgcomp [lindex $a 1] $n] {
      putserv "NOTICE $nick :Ce pseudo est dj enregistr."
      return
    }
  }
  lappend chan-data($c) "ACCESS [join $n] [join $pw] $lv $ao $av $pr 0 [join $h]"
  write $c
  putserv "NOTICE $nick :Utilisateur ajout avec succs."
  dolog 1 adduser "$nick@[nick2hand $nick $c] $c $n ($lv)"
}

proc cs::csauth {nick host hand arg} {
 variable admin-data
 variable auth
 variable chanlog 
  if {[llength $arg]!=2} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick CSAUTH <Login> <mot-de-passe>"
    return
  }
  if ![onchan $nick $chanlog] {
    putserv "NOTICE $nick :Vous devez tre sur $chanlog pour vous CsAuth"
    putserv "INVITE $nick $chanlog"
    return
  }
  set n [lindex $arg 0]
  set p [lindex $arg 1]
  set h $nick!$host
  foreach a ${admin-data} {
    set a [split $a]
    if {[lindex $a 0]!="ACCESS"} {continue}
    if [stgcomp [lindex $a 1] $n] {
      set dn [lindex $a 1]
      set dp [lindex $a 2]
      set dl [lindex $a 3]
      set di [lrange $a 4 7]
      set dh [lrange $a 8 end]
      break
    }
  }
  if ![info exists dn] {
    putserv "NOTICE $nick :Pas d accs."
    dolog 0 csauth "$nick@[lindex $arg 0] Pas d accs"
    return
  }
  set x 0
  foreach h1 $dh {
    if [hostcomp [join $h1] [join $h]] {
      set x 1
      break
    }
  }
  if !$x {
    putserv "NOTICE $nick :Mauvais host."
    dolog 0 csauth "$nick@[lindex $arg 0] Mauvais host"
    return
  }
  if {$p!=$dp} {
    putserv "NOTICE $nick :Mauvais pass."
    dolog 0 csauth "$nick@[lindex $arg 0] Mauvais pass"
    return
  }
  if [info exists auth([string tolower $dn],*)] {
    if {[lindex $auth([string tolower $dn],*) 0]==$nick} {
      putserv "NOTICE $nick :Dj identifi."
      dolog 0 csauth "$nick@[lindex $arg 0] Dj identifi"
      return
    } else {
      unset -nocomplain auth([string tolower $dn],*)
    }
  }
  if [lindex $di 3] {
    putserv "NOTICE $nick :Votre accs est suspendu."
    dolog 0 auth "$nick@$n $c Accs suspendu"
    return
  }
  set auth([string tolower $dn],*) "$nick $dn * $dl"
  putserv "NOTICE $nick :Vous tes identifi."
  dolog 1 csauth "$nick@[lindex $arg 0] $dl"
  foreach c [channels] {
    if {[lindex $di 1] && [channel get $c setvoice]} {putquick "MODE $c +v $nick"} 
    if {[lindex $di 0] && [channel get $c autoops]} {putquick "MODE $c +o $nick"}
  }
}

proc cs::auth {nick host hand arg} {
 variable chan-data
 variable auth
 variable chanlog
  set c [string tolower [lindex $arg 0]]
  set n [lindex $arg 1]
  set p [lindex $arg 2]
  set h $nick!$host
  if {[llength $arg]!=3} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick AUTH <#salon> <Login> <mot-de-passe>"
    return
  }
  if {[string index $c 0]!="#" || ![validchan $c] || ![info exists chan-data($c)]} {
    putserv "NOTICE $nick :salon invalide."
    return
  }
  if ![onchan $nick $c] {
    putserv "NOTICE $nick :Vous devez tre sur $c pour vous auth."
    return
  }
  foreach a [set chan-data($c)] {
    set a [split $a]
    if {[lindex $a 0]!="ACCESS"} {continue}
    if [stgcomp [lindex $a 1] $n] {
      set dn [lindex $a 1]
      set dp [lindex $a 2]
      set dl [lindex $a 3]
      set di [lrange $a 4 7]
      set dh [lrange $a 8 end]
      break
    }
  }
  if ![info exists dn] {
    putserv "NOTICE $nick :Pas d accs."
    dolog 0 auth "$nick@$n $c Pas d accs"
    return
  }
  set x 0
  foreach h1 $dh {
    if [hostcomp [join $h1] [join $h]] {
      set x 1
      break
    }
  }
  if !$x {
    putserv "NOTICE $nick :Mauvais host."
    dolog 0 auth "$nick@$n $c Mauvais host"
    return
  }
  if {$p!=$dp} {
    putserv "NOTICE $nick :Mauvais pass."
    dolog 0 auth "$nick@$n $c Mauvais pass"
    return
  }
  if [info exists auth([string tolower $dn],$c)] {
    if {[lindex $auth([string tolower $dn],$c) 0]==$nick} {
      putserv "NOTICE $nick :Dj identifi."
      dolog 0 auth "$nick@$n $c Dj identifi"
      return
    } else {
      unset -nocomplain auth([string tolower $dn],$c)
    }
  }
  if [lindex $di 3] {
    putserv "NOTICE $nick :Votre accs est suspendu."
    dolog 0 auth "$nick@$n $c Accs suspendu"
    return
  }
  if {[lindex $di 0] && [channel get $c autoops]} {putquick "MODE $c +o $nick"}
  if {[lindex $di 1] && [channel get $c setvoice]} {putquick "MODE $c +v $nick"}
  set auth([string tolower $dn],$c) "$nick $dn $c $dl"
  putserv "NOTICE $nick :Vous tes identifi."
  dolog 1 auth "$nick@$n $c $dl"
}

proc cs::Pdelchan {nick host hand chan arg} {
  cs::delchan $nick $host $hand $arg
}

proc cs::delchan {nick host hand arg} {
 variable level
 variable file
 variable auth
 variable chan-data
  set c [string tolower [lindex $arg 0]]
  if {[getlevel [nick2hand $nick]]<$level(delchan)} {
    putserv "NOTICE $nick :Accs refus."
    dolog 0 delchan "$nick@[nick2hand $nick] $arg"
    return
  }
  if {[llength $arg]<1} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick DELCHAN <#salon> <raison>"
    return
  }
  if {[set raison [lrange $arg 1 end]]==""} {set raison "Salon supprim."}
  set f [file join $file(chan-dir) [string trim $c #]]
  if {![validchan $c] || ![file exists $f]} {
    putserv "NOTICE $nick :Salon invalide."
    return
  }
  unset -nocomplain chan-data($c)
  foreach "u i" [array get auth] {
    if [stgcomp [lindex $i 2] $c] {
      unset auth($u)
    }
  }
  putserv "TOPIC $c :$raison"
  file delete $f
  channel remove $c
  putserv "NOTICE $nick :Salon supprim."
  dolog 1 delchan "$nick@[nick2hand $nick] $c :$raison"
}


proc cs::adminreg {nick host hand arg} {
 variable level
 variable file
 variable chan-data
  if {[getlevel [nick2hand $nick]]<$level(adminreg)} {
    putserv "NOTICE $nick :Accs refus."
    dolog 0 adminreg "$nick@[nick2hand $nick]"
    return
  }
  if {[llength $arg]!=4} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick ADMINREG <#salon> <Login> <Host/mask> <mot-de-passe>"
    return
  }
  set chan [string tolower [lindex $arg 0]]
  set login [lindex $arg 1]
  set mask [lindex $arg 2]
  set pass [lindex $arg 3]
  set f [file join $file(chan-dir) [string trim $chan #]]
  if [file exists $f] {
    putserv "NOTICE $nick :Ce salon est dj enregistr."
    return
  }
  if {[string length $pass]<6} {
    putserv "NOTICE $nick :Le mot de passe doit contenir 6 caractres minimum."
    return
  }
  if ![string match *!*@* $mask] {
    putserv "NOTICE $nick :Mask invalide, il doit tre sous la forme Pseudo!Ident@Host"
    putserv "NOTICE $nick :Exemples Oracle*!*@* , Oracle*!*foo*@*.fr , Oracle!foo@*.fr"
    return
  }
  if {[string length $mask] < 8} {
    putserv "NOTICE $nick :le mask est trop imprcis, minimum 8 caratres."
    return
  }
  set chan-data($chan) [list "CREATE [unixtime] [nick2hand $nick]" "ACCESS [join $login] [join $pass] 500 0 0 1 0 [join $mask]" "DEFMODES +nt"]
  catch {open $f w+} p
  puts $p "CREATE [unixtime] [nick2hand $nick]"
  puts $p "ACCESS [join $login] [join $pass] 500 0 0 1 0 [join $mask]"
  puts $p "DEFMODES +nt"
  catch {close $p} 
  chan_add $chan
  putserv "NOTICE $nick :Salon ajout avec succs."
  dolog 1 adminreg "$nick@[nick2hand $nick] $chan owner: $login"
}

proc cs::op {nick host hand chan arg} {
  variable level
  if {$arg==""} {set arg $nick}
  if {[getlevel [nick2hand $nick $chan] $chan]>=$level(op)} {
    if ![isop [lindex $arg 0] $chan] {
      if {[getlevel [nick2hand [lindex $arg 0] $chan] $chan]<$level(op) && [channel get $chan strictop]} {
        putserv "NOTICE $nick :Le mode strictop est activ."
        return
      }
      if [channel get $chan noop] {
        putserv "NOTICE $nick :Le mode noop est activ."
        return
      }
      putquick "MODE $chan +o [lindex $arg 0]"
      dolog 1 op "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
    }
  } else {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 op "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
  }
}

proc cs::deop {nick host hand chan arg} {
  variable level
  if {$arg==""} {set arg $nick}
  if {[getlevel [nick2hand $nick $chan] $chan]>=$level(deop)} {
    if [isop [lindex $arg 0] $chan] {
      putquick "MODE $chan -o [lindex $arg 0]"
      dolog 1 deop "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
    }
  } else {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 deop "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
  }
}

proc cs::voice {nick host hand chan arg} {
  variable level
  if {$arg==""} {set arg $nick}
  if {[getlevel [nick2hand $nick $chan] $chan]>=$level(voice)} {
    if ![isvoice [lindex $arg 0] $chan] {
      putquick "MODE $chan +v [lindex $arg 0]"
      dolog 1 voice "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
    }
  } else {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 voice "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
  }
}

proc cs::devoice {nick host hand chan arg} {
  variable level
  if {$arg==""} {set arg $nick}
  if {[getlevel [nick2hand $nick $chan] $chan]>=$level(devoice)} {
    if [isvoice [lindex $arg 0] $chan] {
      putquick "MODE $chan -v [lindex $arg 0]"
      dolog 1 devoice "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
    }
  } else {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 devoice "$nick@[nick2hand $nick $chan] $chan [lindex $arg 0]"
  }
}

proc cs::infoline {nick host hand chan arg} {
 variable level
 variable file
 variable chan-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(info)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 info "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  if {$arg==""} {
    putserv "NOTICE $nick :Syntaxe: /msg $::botnick INFO <#salon> <votre texte/del>"
    return
  }
  set x 0
  set y 0
  foreach data [set chan-data($chan)] {
    if {[lindex $data 0]=="INFO" && [stgcomp [nick2hand $nick $chan] [lindex $data 1]]} {
      if [stgcomp [lindex $arg 0] "del"] {
        set chan-data($chan) [lreplace [set chan-data($chan)] $x $x]
        putserv "NOTICE $nick :Votre infoline  t supprime."
        dolog 1 info "$nick@[nick2hand $nick $chan] $chan $arg"
        set y 1
        break
      } else {
        set chan-data($chan) [lreplace [set chan-data($chan)] $x $x "INFO [lindex $data 1] [join $arg]"]
        putserv "NOTICE $nick :Votre infoline  t modifie."
        dolog 1 info "$nick@[nick2hand $nick $chan] $chan $arg"
        set y 1
        break
      }
    }
    incr x
  }
  if !$y {
    if ![stgcomp [lindex $arg 0] "del"] {
      lappend chan-data($chan) "INFO [nick2hand $nick $chan] [join $arg]"
      putserv "NOTICE $nick :Votre infoline  t ajoute."
    } else {
      putserv "NOTICE $nick :Vous n'avez pas d'infoline."
    }
    dolog 1 info "$nick@[nick2hand $nick $chan] $chan $arg"
  }
}

proc cs::access {nick host hand chan arg} {
 variable level
 variable auth
 variable chan-data
  if {$arg==""} {set arg *}
  if {[getlevel [nick2hand $nick $chan] $chan]>=$level(access)} {
    set chan [string tolower $chan]
    set info [lindex $arg 0]
    set x 0
    putquick "NOTICE $nick :\00301 Accs sur \037\00314$chan\037 \00301"
    foreach data [set chan-data($chan)] {
      if {[lindex $data 0]=="ACCESS" && [hostcomp [lindex $arg 0] [lindex $data 1]]} {
        incr x
        putquick "NOTICE $nick :\037\00301Nom\037 \037d'utilisateur\037: \00302[lindex $data 1]\003  \037Level\037: \00314[lindex $data 3]\003"
        putquick "NOTICE $nick :\037\00301Host/mask\037: \00310[join [lrange $data 8 end]]\003"
        putquick "NOTICE $nick :\037\00301Autoop\037: [getinfo [lindex $data 1] autoop $chan]  \037Protect\037: [getinfo [lindex $data 1] protect $chan]  \037Voice\037: [getinfo [lindex $data 1] autovoice $chan]  \037Suspend\037: [getinfo [lindex $data 1] suspend $chan]"
      }
    }
    putquick "NOTICE $nick :\00301 Nombre d'Accs trouv sur \037\00314$chan\037 \00301-\002 $x\002 - \003"
    dolog 1 access "$nick@[nick2hand $nick $chan] $chan $arg"
  } else {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 access "$nick@[nick2hand $nick $chan] $chan $arg"
  }
}

proc cs::alist {nick host hand chan arg} {
 variable level
 variable auth
 variable chan-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(alist)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 alist "$nick@[nick2hand $nick $chan] $chan $arg"
    return
  }
  set x 0
  set y 0
  putquick "NOTICE $nick :\00301 Liste des authentifis sur \037\00314$chan\037\00301 "
  putquick "NOTICE $nick :\00301\037Login/username\037  \037Pseudo\037  \037Level\037"
  foreach data [set chan-data($chan)] {
    if {[lindex $data 0]=="ACCESS"} {
      incr x
      set n [lindex $data 1]
      if {[hand2nick $n $chan]!="*"} {
        incr y
        putquick "NOTICE $nick :\00301$n  \00310[hand2nick $n $chan]\00301  \00302[getlevel $n $chan]"
      }
    }
  }
  putquick "NOTICE $nick :\00301 Nombre d'authentifi sur \037\00314$chan\037\00301 - \00304(\002\00301$y/$x\002\00304)\00301 "
  dolog 1 alist "$nick@[nick2hand $nick $chan] $chan $arg"
}

proc cs::csadmin {nick host hand arg} {
  set chan [lindex $arg 0]
  cs::Pcsadmin $nick $host $hand $chan [join [lrange $arg 1 end]]
}

proc cs::Pcsadmin {nick host hand chan arg} {
 variable level
 variable auth
 variable admin-data
  set chan [string tolower $chan]
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(csadmin)} {
    putquick "NOTICE $nick :Accs refus."
    dolog 0 csadmin "$nick@[nick2hand $nick $chan]"
    return
  }
  set x 0
  set y 0
  foreach data [set admin-data] {
    if {[lindex $data 0]=="ACCESS"} {
      incr x
      set n [lindex $data 1]
      if !$y {
        putquick "NOTICE $nick :\00301 Liste des csadmins "
        putquick "NOTICE $nick :\00301\037Login/username\037  \037Pseudo\037  \037Level\037"
      }
      if {[hand2nick $n]!="*"} {incr y}
      putquick "NOTICE $nick :\00301$n  \00310[hand2nick $n]\00301  \00302[lindex $data 3]"
    }
  }
  putquick "NOTICE $nick :\00301 Nombre d'authentifi - \00304(\002\00301$y/$x\002\00304)\00301 "
  dolog 1 csadmin "$nick@[nick2hand $nick $chan]"
}

proc cs::Pversion {nick host hand chan arg} {
  set arg "$chan $arg"
  cs::version $nick $host $hand [join $arg]
}
proc cs::version {nick host hand arg} {
  putquick "NOTICE $nick :IriX V$cs::version"
  dolog 1 version "$nick@[nick2hand $nick [lindex $arg 0]]"
}





}]



 

#putlog "CService.tcl charg."
putlog "CService.tcl V$cs::version charg en [expr [lindex [set cs::time] 0]/1000.000] millisecondes."
