variable file
set file(dir) [file join [pwd] scripts CS-data] 
set file(admins) [file join $file(dir) admins] 
set file(chan-dir) [file join $file(dir) chans]

variable version 3
variable chan-data
variable admin-data

variable level
#set level(auth) 0
#set level(csauth) 0
set level(version) 0
set level(csadmin) 1
set level(chaninfo) 50
set level(voice) 50
set level(devoice) 50
set level(access) 50
set level(info) 50
set level(kick) 100
set level(ban) 100
set level(alist) 100
set level(topic) 100
set level(op) 100
set level(deop) 100
set level(unban) 100
set level(mode) 100
set level(banlist) 100
set level(newpass) 100
set level(kickban) 300
set level(rdefmodes) 300
set level(rdeftopic) 300
set level(rdefaults) 300
set level(say) 300
set level(do) 300
set level(voiceall) 300
set level(devoiceall) 300
set level(opall) 400
set level(deopall) 400
set level(clearmodes) 400
set level(clearbans) 400
set level(addmask) 400
set level(delmask) 400
#set level(autoop) 400
#set level(protect) 400
#set level(level) 400
set level(moderate) 450
set level(bantimeout) 450
set level(adduser) 450
set level(deluser) 450
set level(noop) 450
set level(noban) 450
set level(strictop) 450
set level(lockmodes) 450
set level(locktopic) 450
set level(strictmodes) 450
set level(defmodes) 450
set level(deftopic) 450
set level(autoops) 450
set level(setvoice) 450
set level(chmodeslevel) 450
set level(banlevel) 450


#set level(csdeauth) 501
set level(chanlist) 501
#set level(cswall) 501
#set level(inviteme) 501
#set level(isauthed) 501
#set level(verifypass) 501
#set level(ainfo) 501
#set level(adeauth) 501
set level(adminreg) 700
set level(delchan) 700
#set level(adminsuspend) 700
#set level(adminunsuspend) 700
#set level(suspendchan) 700
#set level(desuspendchan) 700
#set level(chowner) 700
#set level(doall) 800
#set level(sayall) 800
set level(addadmin) 900
set level(deladmin) 900
#set level(adminpass) 900
#set level(modadmin) 900
set level(restart) 1000
set level(rehash) 1000
#set level(die) 1000
#set level(showdiscom) 1000
#set level(enablecom) 1000
#set level(disablecom) 1000

setudef flag strictop
setudef flag strictmodes
setudef flag lockmodes
setudef flag noop
setudef flag noban
setudef flag locktopic
setudef flag autoops
setudef flag setwelcome
setudef flag setvoice

########################################################

proc chan_add chan {
  channel add $chan {
    chanmode "+nt"
    idle-kick 0
    stopnethack-mode 0
    revenge-mode 0
    ban-time 0
    exempt-time 0
    invite-time 0
    aop-delay 5:30
    need-op {  }
    need-invite {  }
    need-key {  }
    need-unban {  }
    need-limit {  }
    flood-chan 0:0
    flood-deop 0:0
    flood-kick 0:0
    flood-join 0:0
    flood-ctcp 0:0
    flood-nick 0:0
  } 
  channel set $chan -autoop -autovoice -bitch +cycle -dontkickops -dynamicbans -dynamicexempts -dynamicinvites -enforcebans +greet -inactive +nodesynch -protectfriends -protectops -revenge -revengebot -secret -seen -shared -statuslog +userbans -userexempts -userinvites -protecthalfops -autohalfop  
  savechannels
  putquick "JOIN $chan"
  putquick "MODE +o $chan"
}

if ![file exists $file(dir)] {
  file mkdir $file(dir)
}
if ![file exists $file(chan-dir)] {
  file mkdir $file(chan-dir)
}
if ![file exists $file(admins)] {
  catch {open $file(admins) w+} p
  puts $p "ACCESS [join $admin(hand)] [join $admin(pass)] 10000 0 0 1 0 [join $admin(host)]"
  catch {close $p}
  unset -nocomplain p
  chan_add $chanlog
}

unset -nocomplain admin-data
catch {open $file(admins) r} p
while {![eof $p]} {
  set data [split [gets $p]]
  if {[lindex $data 0]=="#"} continue
  if {$data!=""} {lappend admin-data [join $data]}
}
catch {close $p}
unset -nocomplain data
unset -nocomplain p

proc write chan {
 variable file
 variable chan-data
 variable admin-data
  if {$chan=="admin"} {
    set f $file(admins)
    if {[set admin-data]==""} {
      putlog "\\002\00304CS-Error\003 Impossible d'crire le fichier admin ($f)"
      putlog "ncessite un restart (toutes les donnes non sauvegard seront perdu)"
      return
    }
    catch {open $f w+} p
    foreach data [set admin-data] {
      puts $p [join $data]
    }
    catch {close $p}
    return 1
  } elseif [validchan $chan] {
    set f [file join $file(chan-dir) [string trim $chan #]]
    if ![file exists $f] {return 0}
    if {[set chan-data([string tolower $chan])]==""} {
      putlog "\\002\00304CS-Error\003 Impossible d'crire le fichier $chan ($f)"
      putlog "ncessite un restart (toutes les donnes non sauvegard seront perdu)"
      return 0
    }
    catch {open $f w+} p
    foreach data [set chan-data([string tolower $chan])] {
      puts $p [join $data]
    }
    catch {close $p}
    return 1
  }
}

########################################################

bind time - "* * * * *" cs::verify_ban
bind evnt - save cs::save_file

proc save_file {type} {
 variable admin-data
 variable chan-data
  if [write admin] {putlog "criture du fichier csadmin"}
  foreach c [channels] {
    if [write $c] {putlog "criture du fichier $c"}
  }
}

proc verify_ban {m h j mo a} {
 variable chan-data
  foreach chan [string tolower [join [channels]]] {
    set timeout [channel get $chan ban-time]
    foreach b [chanbans $chan] {
      if {$timeout!=0 && [lindex $b end]>=[expr $timeout*60]} {
        putserv "MODE $chan -b [lindex $b 0]"
      }
    }
    if [info exists chan-data($chan)] {
      set x 0
      while {$x<[llength [set chan-data($chan)]]} {
        if {[lindex [set chan-data($chan)] $x 0]!="BAN"} {incr x;continue}
        if {[lindex [set chan-data($chan)] $x 3]!=0 && [lindex [set chan-data($chan)] $x 3]<=[unixtime]} {
          foreach b [chanbans $chan] {
            if [stgcomp [lindex [set chan-data($chan)] $x 1] [lindex $b 0]] {
              putserv "MODE $chan -b [lindex [set chan-data($chan)] $x 1]"
            } 
          }
          set chan-data($chan) [lreplace [set chan-data($chan)] $x $x]
          continue
        }
        incr x
      }
    }
  }
}

proc dolog {type cmd arg} {
  set arg [split $arg]
  if $type {
    puthelp "PRIVMSG $cs::chanlog :\00301\[\00303[string toupper $cmd]\00301\] \002[lindex $arg 0]\002 [join [lrange $arg 1 end]]"
  } else {
    puthelp "PRIVMSG $cs::chanlog :\00301\[\00304[string toupper $cmd]\00301\] \002[lindex $arg 0]\002 [join [lrange $arg 1 end]]"
  }
}

proc stgcomp {arg1 arg2} {string equal -nocase $arg1 $arg2}

proc hostcomp {host1 host2} {string match -nocase [string map {"\[" "." "\]" ","} [join $host1]] [string map {"\[" "." "\]" ","} [join $host2]]}

proc getlevel {hand {chan "*"}} {
 variable auth
  set chan [string tolower $chan]
  foreach "u a" [array get auth] {
    if {[stgcomp $hand [lindex [split $u ,] 0]] && ([lindex $a 2]=="*" || [stgcomp [lindex $a 2] $chan])} {return [lindex $a 3]}
  }
  return 0
}

proc nick2hand {nick {chan "*"}} {
 variable auth
  set chan [string tolower $chan]
  foreach "u a" [array get auth] {
    if {[stgcomp [lindex $a 0] $nick] && ([lindex $a 2]=="*" || [stgcomp [lindex $a 2] $chan])} {return [lindex $a 1]}
  }
  return *
}

proc hand2nick {hand {chan "*"}} {
 variable auth
  set chan [string tolower $chan]
  foreach "u a" [array get auth] {
    if {[stgcomp $hand [lindex [split $u ,] 0]] && ([lindex $a 2]=="*" || [stgcomp [lindex $a 2] $chan])} {return [lindex $a 0]}
  }
  return *
}

proc host2nick {host chan} {
  set nicks ""
  foreach n [join [::chanlist $chan]] {
    set h "$n![getchanhost $n $chan]"
    if [hostcomp [join $host] [join $h]] {
      lappend nicks $n
    }
  }
  return $nicks
}

proc ::autobind {level cmd proc} {
  bind pub $level $cs::char$cmd $proc
  set ::p [string map {"::" "%%"} $proc]
  bind msg $level $cmd cs::autobind::$::p
  namespace eval cs::autobind {
    proc [set ::p] {nick host hand arg} {
      set chan [string tolower [lindex $arg 0]]
      if ![validchan $chan] {
        putserv "NOTICE $nick :Salon invalide."
        return
      }
      set arg [lreplace $arg 0 0]
      foreach bind [binds msg] {
        if {[lindex $bind 2]=="$::lastbind" && [string match "cs::autobind::*" [lindex $bind end]]} {
          [string map {"cs::autobind::" "" "%%" "::"} [lindex $bind end]] $nick $host $hand $chan $arg
        }
      }
    }
  }
  unset ::p
}

proc pushmode {chan mode arg} {
  set l ""
  if ![botisop $chan] return
  switch -- $mode {
    +o {
      foreach a $arg {
        if [isop $a $chan] continue
        lappend l $a
        if {[llength $l]==6} {
          putquick "MODE $chan +oooooo [join $l]"
          set l ""
          continue
        }
      }
      if {[llength $l]>0} {
        putquick "MODE $chan +[string repeat o [llength $l]] [join $l]"
        set l ""
      }
    }
    -o {
      foreach a $arg {
        if {![isop $a $chan] || [isbotnick $a]} continue
        lappend l $a
        if {[llength $l]==6} {
          putquick "MODE $chan -oooooo [join $l]"
          set l ""
          continue
        }
      }
      if {[llength $l]>0} {
        putquick "MODE $chan -[string repeat o [llength $l]] [join $l]"
        set l ""
      }
    }
    +v {
      foreach a $arg {
        if [isvoice $a $chan] continue
        lappend l $a
        if {[llength $l]==6} {
          putquick "MODE $chan +vvvvvv [join $l]"
          set l ""
          continue
        }
      }
      if {[llength $l]>0} {
        putquick "MODE $chan +[string repeat v [llength $l]] [join $l]"
        set l ""
      }
    }
    -v {
      foreach a $arg {
        if {![isvoice $a $chan] || [isbotnick $a]} continue
        lappend l $a
        if {[llength $l]==6} {
          putquick "MODE $chan -vvvvvv [join $l]"
          set l ""
          continue
        }
      }
      if {[llength $l]>0} {
        putquick "MODE $chan -[string repeat v [llength $l]] [join $l]"
        set l ""
      }
    }
    -b {
      foreach a $arg {
        lappend l $a
        if {[llength $l]==6} {
          putquick "MODE $chan -bbbbbb [join $l]"
          set l ""
          continue
        }
      }
      if {[llength $l]>0} {
        putquick "MODE $chan -[string repeat b [llength $l]] [join $l]"
        set l ""
      }
    }
  }
}

proc getinfo {hand type {chan ""}} {
  variable chan-data
  variable admin-data
  if {$chan==""} {set f [set admin-data]} else {set f [set chan-data([string tolower $chan])]}
  foreach data $f {
    switch -- $type {
      "autoop" {
        if {[lindex $data 0]=="ACCESS" && [stgcomp $hand [lindex $data 1]]} {
          if [lindex $data 4] {return \00303OUI\00301}
          return \00304NON\00301
        }
      }
      "autovoice" {
        if {[lindex $data 0]=="ACCESS" && [stgcomp $hand [lindex $data 1]]} {
          if [lindex $data 5] {return \00303OUI\00301}
          return \00304NON\00301
        }
      }
      "protect" {
        if {[lindex $data 0]=="ACCESS" && [stgcomp $hand [lindex $data 1]]} {
          if [lindex $data 6] {return \00303OUI\00301}
          return \00304NON\00301
        }
      }
      "suspend" {
        if {[lindex $data 0]=="ACCESS" && [stgcomp $hand [lindex $data 1]]} {
          if [lindex $data 7] {return \00303OUI\00301}
          return \00304NON\00301
        }
      }
    }
  }
} 

proc isprotect {hand {chan ""}} {
  variable chan-data
  variable admin-data
  set x 0
  if {[getlevel $hand $chan]=="0"} {return 0}
  if {$chan==""} {set x 1}
  foreach a [set admin-data] {
    if {[lindex $a 0]=="ACCESS" && [stgcomp $hand [lindex $a 1]] && [lindex $a 6]} {
      return 1
    }
  }
  if $x {return 0}
  foreach a [set chan-data([string tolower $chan])] {
    if {[lindex $a 0]=="ACCESS" && [stgcomp $hand [lindex $a 1]] && [lindex $a 6]} {
      return 1
    }
  }
  return 0
}

proc exptime time {clock format $time -format "%d/%m/%Y %H:%M"}

########################################################

bind nick - * cs::chgnick
bind join - * cs::join_chan
bind part - * cs::part_chan
bind kick - * cs::kick_chan
bind sign - * cs::quit
bind raw - 001 cs::001
bind mode - * cs::modes
bind topc - * cs::topc

proc topc {nick host hand chan topic} {
 variable lasttopic
 variable level
  set chan [string tolower $chan]
  if {![info exists lasttopic($chan)] || [isbotnick $nick] || ![botisop $chan] || [matchattr $hand +b]} {set lasttopic($chan) $topic ; return}
  if [channel get $chan locktopic] {
    if {$lasttopic($chan)!=$topic} {
      putquick "TOPIC $chan :$lasttopic($chan)"
      puthelp "NOTICE $nick :Le mode locktopic est activ."
      return
    } else {
      return
    }
  }
  if {[getlevel [nick2hand $nick $chan] $chan]<$level(topic)} {
    putquick "TOPIC $chan :$lasttopic($chan)"
    return
  }
  set lasttopic($chan) $topic
}

proc modes {nick host hand chan mode target} {
 variable chan-data
 variable level
  set chan [string tolower $chan]
  if {[isbotnick $nick] || ![botisop $chan] || [matchattr $hand +b]} return
  switch -- [lindex $mode 0] {
    +b {
      if [channel get $chan noban] {
        puthelp "NOTICE $nick :Le mode noban est activ."
        putquick "MODE $chan -b $target"
        return
      }
      foreach n [host2nick $target $chan] {
        if {[getlevel [nick2hand $n $chan] $chan]>=[getlevel [nick2hand $nick $chan] $chan]} {
          putquick "MODE $chan -bo $target $nick"
          return
        }
      }
      foreach a [set chan-data($chan)] {
        if {[lindex $a 0]=="BANLEVEL"} {
          set banlevel [lindex $a 1]
          break
        }
      }
      if ![info exists banlevel] {set banlevel $level(ban)}
      if {[getlevel [nick2hand $nick $chan] $chan]<$banlevel} {
        putquick "MODE $chan -b $target"
        return
      } 
    }
    -b {
      if {[getlevel [nick2hand $nick $chan] $chan]<$level(unban)} {
        putquick "MODE $chan +b $target"
        return
      } else {
        set x 0
        foreach a [set chan-data($chan)] {
          if {[lindex $a 0]!="BAN"} {incr x;continue}
          if [stgcomp [lindex $a 1] $target] {
            set chan-data($chan) [lreplace [set chan-data($chan)] $x $x]
            return
          }
          incr x
    }
    if [isban $target $chan] {
           killchanban $chan $target
       }
    }
  }
    +o {
      if [isbotnick $target] return
      if {[getlevel [nick2hand $target $chan] $chan]<$level(op) && [channel get $chan strictop]} {
        puthelp "NOTICE $nick :Le mode strictop est activ."
        putquick "MODE $chan -o $target"
        return
      }
      if [channel get $chan noop] {
        puthelp "NOTICE $nick :Le mode noop est activ."
        putquick "MODE $chan -o $target"
        return
      }
    }
    -o {
      if {![stgcomp $nick $target] && [getlevel [nick2hand $nick $chan] $chan]<=[getlevel [nick2hand $target $chan] $chan] && [isprotect $target $chan]} {
        puthelp "NOTICE $nick :[hand2nick [nick2hand $target $chan] $chan] est un utilisateur protg."
        putquick "MODE $chan +o $target"
      }
    }
    +v { }
    -v { }
    default {
      if [channel get $chan lockmodes] {
        set m [string map {+ - - +} $mode]
        puthelp "NOTICE $nick :Le mode lockmodes est activ."
        putquick "MODE $chan $m $target"
        return
      }
      foreach a [set chan-data($chan)] {
        if {[lindex $a 0]=="CHMODESLEVEL"} {
          set chlevel [lindex $a 1]
          break
        }
      }
      if ![info exists chlevel] {set chlevel $level(mode)}
      if {[getlevel [nick2hand $nick $chan] $chan]<$chlevel && [channel get $chan strictmodes]} {
        set m [string map {+ - - +} $mode]
        putquick "MODE $chan $m $target"
        return
      }
    }
  }
}

proc 001 {f k a} {
 variable auth
  unset -nocomplain auth
}

proc part_chan {nick host hand chan {arg ""}} {
 variable auth
 variable chanlog
  set chan [string tolower $chan]
  if {[nick2hand $nick $chan]!="*" && [getlevel [nick2hand $nick $chan] $chan]<=500} {
    unset -nocomplain auth([string tolower [nick2hand $nick $chan]],$chan)
  } elseif {[stgcomp $chan $chanlog] && [nick2hand $nick]!="*"} {
    unset -nocomplain auth([string tolower [nick2hand $nick]],*)
  }
}

 proc kick_chan {nick host hand chan target arg} {
  variable auth
  variable chanlog
   if [isbotnick $nick] return
   set chan [string tolower $chan]
   if {[nick2hand $target $chan]!="*" && [getlevel [nick2hand $nick $chan] $chan]<=[getlevel [nick2hand $target $chan] $chan] && [isprotect [nick2hand $target $chan] $chan]} {
   if ![matchattr $hand +b] {
   putquick "MODE $chan -o $nick"
   putserv "NOTICE $nick :[hand2nick [nick2hand $target $chan] $chan] est protg."
   return
     }
   } else {
    unset -nocomplain auth([string tolower [nick2hand $target $chan]],$chan)
   } 
 if {[stgcomp $chan $chanlog] && [nick2hand $target]!="*"} {
unset -nocomplain auth([string tolower [nick2hand $target]],*)
}
}

proc quit {nick host hand chan arg} {
 variable auth
  foreach c [string tolower [channels]] {
    if {[nick2hand $nick $c]!="*"} {
      unset -nocomplain auth([string tolower [nick2hand $nick $c]],$c)
    }
  }
  if {[nick2hand $nick]!="*"} {
    unset -nocomplain auth([string tolower [nick2hand $nick $c]],*)
  }
}

proc chgnick {nick host hand arg newnick} {
  variable auth
  if [info exists auth([string tolower [nick2hand $nick]],*)] {
    set auth([string tolower [nick2hand $nick]],*) [join [lset auth([string tolower [nick2hand $nick]],*) 0 $newnick]]
  }
  foreach c [string tolower [channels]] {
    if [info exists auth([string tolower [nick2hand $nick $c]],$c)] {
      set auth([string tolower [nick2hand $nick $c]],$c) [join [lset auth([string tolower [nick2hand $nick $c]],$c) 0 $newnick]]
    }
  }
}

proc join_chan {nick host hand chan} {
  variable chan-data
  set c [string tolower $chan]
  if [isbotnick $nick] {
    set c [string tolower $chan]
    set f [file join $cs::file(chan-dir) [string trim $c #]]
    if ![file exists $f] return
    unset -nocomplain chan-data($c)
    catch {open $f r} p
    while {![eof $p]} {
      gets $p data
      if {$data==""} continue
      lappend chan-data($c) $data
    }
    catch {close $p}
  } else {
    foreach data [set chan-data($c)] {
      if {[lindex $data 0]=="BAN"} {
        if [hostcomp [join [lindex $data 1]] [join $nick!$host]] {
          putquick "MODE $c +b [lindex $data 1]"
          putquick "KICK $c $nick :[join [lrange $data 5 end]]"
          return
        }
      }
      if {[lindex $data 0]=="INFO"} {
        if [hostcomp [join [lindex $data 1]]*!*@* [join $nick!$host]] {puthelp "PRIVMSG $c :\00301\[\002[lindex $data 1]\002\] [join [lrange $data 2 end]]"}
      }
      if {[lindex $data 0]=="ACCESS" && [stgcomp [lindex $data 1] [nick2hand $nick $c]]} {
        if {[lindex $data 5] && [channel get $c setvoice]} {putquick "MODE $chan +v $nick"}
        if {[lindex $data 4] && [channel get $c autoops]} {putquick "MODE $chan +o $nick"}
      } 
    }
  }
}

########################################################

putlog "CSoutils.tcl charg."
